// automatically generated by the FlatBuffers compiler, do not modify

package Serialization;

import java.nio.*;
import java.lang.*;
import java.util.*;
import com.google.flatbuffers.*;

@SuppressWarnings("unused")
public final class StatusChange extends Struct {
  public void __init(int _i, ByteBuffer _bb) { __reset(_i, _bb); }
  public StatusChange __assign(int _i, ByteBuffer _bb) { __init(_i, _bb); return this; }

  public int uid() { return bb.getShort(bb_pos + 0) & 0xFFFF; }
  public byte prevStatus() { return bb.get(bb_pos + 2); }
  public byte status() { return bb.get(bb_pos + 3); }
  public Serialization.Timestamp timestamp() { return timestamp(new Serialization.Timestamp()); }
  public Serialization.Timestamp timestamp(Serialization.Timestamp obj) { return obj.__assign(bb_pos + 8, bb); }

  public static int createStatusChange(FlatBufferBuilder builder, int uid, byte prevStatus, byte status, long timestamp_usecSinceEpoch) {
    builder.prep(8, 16);
    builder.prep(8, 8);
    builder.putLong(timestamp_usecSinceEpoch);
    builder.pad(4);
    builder.putByte(status);
    builder.putByte(prevStatus);
    builder.putShort((short)uid);
    return builder.offset();
  }

  public static final class Vector extends BaseVector {
    public Vector __assign(int _vector, int _element_size, ByteBuffer _bb) { __reset(_vector, _element_size, _bb); return this; }

    public StatusChange get(int j) { return get(new StatusChange(), j); }
    public StatusChange get(StatusChange obj, int j) {  return obj.__assign(__element(j), bb); }
  }
}

